#!/bin/sh

echo "/**"                          
echo " * Generated error macros."   
echo " */"                          
echo "#ifndef RTX_ERRORS_H"         
echo "#define RTX_ERRORS_H"         
echo

sed -e '/^#/d' \
    -e '/./!d' \
    -e 's/"/\\"/g' \
    -e 's/\([A-Z_]*\)[ \t]*\(-[0-9]*\)[ \t]*\(.*\)/'\
'#define RTX_ERROR_\1 \2 \n'\
'#define RTX_FORMAT_\1 "\3" \n'\
'#define RTX_PUSH_\1(error, args...) \\\n'\
'  rtx_error_push(error, __func__, __FILE__, __LINE__, RTX_FORMAT_\1, ##args), RTX_ERROR_\1\n/'

echo 	                         
echo "#endif /* RTX_ERRORS_H */"
